/*
 *  CoreAudioMixer.cpp
 *  CoreAudioJavaSoundLib
 *
 *  Created by Klaus Jaensch on 31.01.12.
 *  Copyright 2012 __MyCompanyName__. All rights reserved.
 *
 */

#include "CoreAudioMixer.h"
#include "CoreAudioDataLine.h"
#include <CoreFoundation/CFString.h>
#include <CoreFoundation/CoreFoundation.h>
#include <CoreAudio/CoreAudioTypes.h>
#include <CoreAudio/AudioHardware.h>
//#include <HostTime.h>
#include <CoreAudio/CoreAudio.h>


JNIEXPORT jstring JNICALL Java_ips_audio_coreaudio_CoreAudioMixer_getName(JNIEnv *env, jobject obj,jobject audioDeviceId) {
	AudioObjectPropertyAddress propertyAddress;
	propertyAddress.mScope    = kAudioObjectPropertyScopeWildcard;
	propertyAddress.mElement  = kAudioObjectPropertyElementMaster;
	propertyAddress.mSelector=kAudioDevicePropertyDeviceNameCFString;
	AudioDeviceID* devIdP=(AudioDeviceID*)env->GetDirectBufferAddress(audioDeviceId);
	UInt32 devOs;
	AudioObjectGetPropertyDataSize(*devIdP,&propertyAddress,0,NULL,&devOs);
	CFStringRef name=(CFStringRef)malloc(devOs);
	AudioObjectGetPropertyData(*devIdP,&propertyAddress,0,NULL,&devOs,&name);
	
	
	
	const char * nameC=CFStringGetCStringPtr(name,NULL);
	//printf("Name %s\n",nameC);
	jstring nameJ=env->NewStringUTF(nameC);
	
	return nameJ;
}

static void enumerateStreams(JNIEnv *env, jobject obj,jobject audioDeviceId,jboolean capture,jmethodID mId){
	AudioDeviceID* devIdP=(AudioDeviceID*)env->GetDirectBufferAddress(audioDeviceId);
	AudioDeviceID devId=*devIdP;
	
		
	UInt32 dataSize;
    
	AudioObjectPropertyAddress propertyAddress;
    propertyAddress.mSelector = kAudioDevicePropertyStreams;
    propertyAddress.mScope    =  capture ? kAudioDevicePropertyScopeInput : kAudioDevicePropertyScopeOutput;
	propertyAddress.mElement  = kAudioObjectPropertyElementMaster;
    //propertyAddress.mElement  = 0;
    
    //AudioDeviceGetPropertyInfo(devId, 0, capture, kAudioDevicePropertyStreams, &dataSize,NULL);
    OSStatus result = AudioObjectGetPropertyDataSize(devId, &propertyAddress, 0, NULL, &dataSize);
	
    
	if(result==0){
		AudioStreamID* streamIds=(AudioStreamID*)malloc(dataSize);
		//AudioDeviceGetProperty(devId, 0, capture, kAudioDevicePropertyStreams, &dataSize,streamIds);
        AudioObjectGetPropertyData(devId, &propertyAddress, 0, NULL, &dataSize, streamIds);
        for(unsigned int i=0;i<dataSize/sizeof(AudioStreamID);i++){
			dataline* dl=(dataline*)malloc(sizeof(dataline));
			dl->deviceID=devId;
			dl->streamID=streamIds[i];
			dl->running=false;
			dl->bufferSize=0;
			dl->writePos=0;
			dl->readPos=0;
			dl->isPlayback=!capture;
			jobject dlId=env->NewDirectByteBuffer(dl,sizeof(dataline));
			env->CallVoidMethod(obj,mId,dlId);
			//printf("Stream %d\n",i);
			//fflush(stdout);
			/*
			 UInt32 devOs;
			 propertyAddress.mSelector=kAudioStreamPropertyAvailablePhysicalFormats;
			 AudioStreamGetPropertyInfo(streamIds[i], 0, kAudioStreamPropertyAvailablePhysicalFormats, &devOs, NULL);
			 AudioStreamRangedDescription* rds=(AudioStreamRangedDescription*)malloc(devOs);
			 AudioStreamGetProperty(streamIds[i],0,kAudioStreamPropertyAvailablePhysicalFormats,&devOs,rds);
			 
			 for(int j=0;j<devOs/(sizeof(AudioStreamRangedDescription));j++){
			 AudioStreamRangedDescription rd=rds[j];
			 
			 printf("RD: %d %f\n",rd.mFormat.mChannelsPerFrame,rd.mFormat.mSampleRate);
			 }
			 */
		}
		
	}else{
		printf("could not get streams\n");
	}
	
}

JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioMixer_enumeratePlaybackStreams(JNIEnv *env, jobject obj,jobject audioDeviceId){
	jclass cls=env->FindClass("ips/audio/coreaudio/CoreAudioMixer");
	if(cls==NULL){
		fprintf(stderr,"Java Class not found!");
		return;
	}
	jmethodID mId=env->GetMethodID(cls,"nextPlaybackStream","(Ljava/nio/ByteBuffer;)V");
	if(mId==NULL){
		fprintf(stderr,"Method not found!");
		return;
	}
	
	enumerateStreams(env,obj,audioDeviceId,FALSE,mId);	
}


JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioMixer_enumerateCaptureStreams(JNIEnv *env, jobject obj,jobject audioDeviceId){
	jclass cls=env->FindClass("ips/audio/coreaudio/CoreAudioMixer");
	if(cls==NULL){
		fprintf(stderr,"Java Class not found!");
		return;
	}
	jmethodID mId=env->GetMethodID(cls,"nextCaptureStream","(Ljava/nio/ByteBuffer;)V");
	if(mId==NULL){
		fprintf(stderr,"Method not found!");
		return;
	}
	enumerateStreams(env,obj,audioDeviceId,TRUE,mId);	
	
		
}
